Index: package_tags/sipb-xen-chrony-config/1/debian/changelog
===================================================================
--- package_tags/sipb-xen-chrony-config/1/debian/changelog	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/debian/changelog	(revision 356)
@@ -0,0 +1,5 @@
+sipb-xen-chrony-config (1) unstable; urgency=low
+
+  * Initial release.
+
+ -- SIPB Xen Project <sipb-xen@mit.edu>  Sun, 30 Mar 2008 06:23:10 -0400
Index: package_tags/sipb-xen-chrony-config/1/debian/compat
===================================================================
--- package_tags/sipb-xen-chrony-config/1/debian/compat	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/debian/compat	(revision 356)
@@ -0,0 +1,1 @@
+5
Index: package_tags/sipb-xen-chrony-config/1/debian/control
===================================================================
--- package_tags/sipb-xen-chrony-config/1/debian/control	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/debian/control	(revision 356)
@@ -0,0 +1,15 @@
+Source: sipb-xen-chrony-config
+Section: misc
+Priority: important
+Maintainer: sipb-xen@mit.edu
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 5), config-package-dev
+Standards-Version: 3.7.2
+
+Package: sipb-xen-chrony-config
+Architecture: all
+Provides: ${diverted-files}
+Conflicts: ${diverted-files}
+Depends: ${shlibs:Depends}, ${misc:Depends}, chrony
+Description: Chrony configuration package for sipb-xen VMs
+ This package should be installed on sipb-xen VMs to maintain
+ an accurate clock
Index: package_tags/sipb-xen-chrony-config/1/debian/control.in
===================================================================
--- package_tags/sipb-xen-chrony-config/1/debian/control.in	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/debian/control.in	(revision 356)
@@ -0,0 +1,15 @@
+Source: sipb-xen-chrony-config
+Section: misc
+Priority: important
+Maintainer: sipb-xen@mit.edu
+Build-Depends: @cdbs@
+Standards-Version: 3.7.2
+
+Package: sipb-xen-chrony-config
+Architecture: all
+Provides: ${diverted-files}
+Conflicts: ${diverted-files}
+Depends: ${shlibs:Depends}, ${misc:Depends}, chrony
+Description: Chrony configuration package for sipb-xen VMs
+ This package should be installed on sipb-xen VMs to maintain
+ an accurate clock
Index: package_tags/sipb-xen-chrony-config/1/debian/copyright
===================================================================
--- package_tags/sipb-xen-chrony-config/1/debian/copyright	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/debian/copyright	(revision 356)
@@ -0,0 +1,3 @@
+This package was created for internal use of the SIPB Xen Project of
+the MIT Student Information Processing Board.  Ask sipb-xen@mit.edu if
+you have questions about redistribution.
Index: package_tags/sipb-xen-chrony-config/1/debian/rules
===================================================================
--- package_tags/sipb-xen-chrony-config/1/debian/rules	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/debian/rules	(revision 356)
@@ -0,0 +1,9 @@
+#!/usr/bin/make -f
+
+DEB_AUTO_UPDATE_DEBIAN_CONTROL = 1
+DEB_DIVERT_EXTENSION = .sipb-xen
+DEB_DIVERT_FILES_sipb-xen-chrony-config += \
+	/etc/chrony.conf
+
+include /usr/share/cdbs/1/rules/debhelper.mk
+include /usr/share/cdbs/1/rules/replace-files.mk
Index: package_tags/sipb-xen-chrony-config/1/debian/sipb-xen-chrony-config.install
===================================================================
--- package_tags/sipb-xen-chrony-config/1/debian/sipb-xen-chrony-config.install	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/debian/sipb-xen-chrony-config.install	(revision 356)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/sipb-xen-chrony-config/1/files/etc/chrony/chrony.conf.sipb-xen
===================================================================
--- package_tags/sipb-xen-chrony-config/1/files/etc/chrony/chrony.conf.sipb-xen	(revision 356)
+++ package_tags/sipb-xen-chrony-config/1/files/etc/chrony/chrony.conf.sipb-xen	(revision 356)
@@ -0,0 +1,87 @@
+# This the default chrony.conf file for the Debian chrony package.  It is
+# suitable for a system with an intermittent dial-up connection.  After
+# editing this file use the command 'invoke-rc.d chrony restart' to make
+# your changes take effect.  
+# John Hasler <jhasler@debian.org> 3 Dec. 1998
+
+# See www.pool.ntp.org for an explanation of these servers.  Please
+# consider joining the project if possible.  If you can't or don't want to
+# use these servers I suggest that you try your ISP's nameservers.  We mark
+# the servers 'offline' so that chronyd won't try to connect when the link
+# is down.  Scripts in /etc/ppp/ip-up.d and /etc/ppp/ip-down.d use chronyc
+# commands to switch it on when the link comes up and off when it goes
+# down.  If you have an always-on connection such as cable omit the
+# 'offline' directive and chronyd will default to online.
+
+server time.mit.edu
+server tick.mit.edu
+
+# Look here for the admin password needed for chronyc.  The initial
+# password is generated by a random process at install time.  You may
+# change it if you wish.
+
+keyfile /etc/chrony/chrony.keys
+
+# Set runtime command key.  Note that if you change the key (not the
+# password) to anything other than 1 you will need to edit
+# /etc/ppp/ip-up.d/chrony, /etc/ppp/ip-down.d/chrony, and
+# /etc/cron.weekly/chrony as these scripts use it to get the password.
+
+commandkey 1
+
+# I moved the driftfile to /var/lib/chrony to comply with the Debian
+# filesystem standard.
+
+driftfile /var/lib/chrony/chrony.drift
+
+# Comment this line out to turn off logging.
+
+log tracking measurements statistics
+logdir /var/log/chrony
+
+# Stop bad estimates upsetting machine clock.
+
+maxupdateskew 100.0
+
+# Dump measurements when daemon exits.
+
+dumponexit
+
+# Specify directory for dumping measurements.
+
+dumpdir /var/lib/chrony
+
+# Let computer be a server when it is unsynchronised.
+
+local stratum 10
+
+# Allow computers on the unrouted nets 10 and 192.168 to use the server.
+
+allow 10/8
+allow 192.168/16
+allow 172.16/12
+
+# This directive forces `chronyd' to send a message to syslog if it
+# makes a system clock adjustment larger than a threshold value in seconds.
+
+logchange 0.5
+
+# This directive defines an email address to which mail should be sent
+# if chronyd applies a correction exceeding a particular threshold to the
+# system clock.
+
+# mailonchange root@localhost 0.5
+
+# This directive tells chrony to regulate the real-time clock and tells it
+# Where to store related data.  It may not work on some newer motherboards
+# that use the HPET real-time clock.  It requires enhanced real-time
+# support in the kernel.
+
+rtcfile /var/lib/chrony/chrony.rtc
+
+# If the last line of this file reads 'rtconutc' chrony will assume that
+# the CMOS clock is on UTC (GMT).  If it reads '# rtconutc' or is absent
+# chrony will assume local time.  The line (if any) was written by the
+# chrony postinst based on what it found in /etc/default/rcS.  You may
+# change it if necessary. 
+rtconutc