Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/changelog
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/changelog	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/changelog	(revision 452)
@@ -0,0 +1,5 @@
+sipb-xen-guest-installer (1.0) unstable; urgency=low
+
+  * Initial release.
+
+ -- Greg Price <price@mega-man.mit.edu>  Tue, 16 Oct 2007 03:01:08 -0400
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/compat
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/compat	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/compat	(revision 452)
@@ -0,0 +1,1 @@
+4
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/control
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/control	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/control	(revision 452)
@@ -0,0 +1,12 @@
+Source: sipb-xen-remctl-auto
+Section: net
+Priority: extra
+Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 4.1.0)
+Standards-Version: 3.7.2
+
+Package: sipb-xen-remctl-auto
+Architecture: all
+Depends: ${misc:Depends}, remctl-server
+Description: Installs the SIPB Xen automatic remctl management system
+ This is our automatic remctl configuration management system.
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/control.in
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/control.in	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/control.in	(revision 452)
@@ -0,0 +1,12 @@
+Source: sipb-xen-guest-installer
+Section: net
+Priority: extra
+Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
+Build-Depends: @cdbs@
+Standards-Version: 3.7.2
+
+Package: sipb-xen-guest-installer
+Architecture: all
+Depends: ${misc:Depends}
+Description: SIPB Xen automatic guest-image installer system
+ This is our automatic guest-image installer system.
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/copyright
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/copyright	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/copyright	(revision 452)
@@ -0,0 +1,3 @@
+This package was created for internal use of the SIPB Xen Project of
+the MIT Student Information Processing Board.  Ask tabbott@mit.edu if
+you have questions about redistribution.
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/rules
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/rules	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/rules	(revision 452)
@@ -0,0 +1,4 @@
+#!/usr/bin/make -f
+
+DEB_AUTO_UPDATE_DEBIAN_CONTROL = 1
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/sipb-xen-guest-installer.install
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/sipb-xen-guest-installer.install	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/sipb-xen-guest-installer.install	(revision 452)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/sipb-xen-guest-installer.postinst
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/sipb-xen-guest-installer.postinst	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/debian/sipb-xen-guest-installer.postinst	(revision 452)
@@ -0,0 +1,53 @@
+#!/bin/sh
+# postinst script for sipb-xen-guest-installer
+#
+# see: dh_installdeb(1)
+
+set -e
+set -x
+
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+#        * <old-postinst> `abort-upgrade' <new version>
+#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
+#          <new-version>
+#        * <postinst> `abort-remove'
+#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
+#          <failed-install-package> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    configure)
+	for d in /srv/guest-installer/*; do
+	    # download the actual iso, unpack it, patch it.
+	    wget -nc -i $d/iso.url -O $d/cdrom.orig.iso
+	    MOUNTDIR=$(mktemp -d /mnt/sipb-xen-guest-installer.cdrom.XXXXXX)
+	    mount -t iso9660 -o loop $d/cdrom.orig.iso $MOUNTDIR
+	    rm -rf $d/cdrom.orig; cp -a $MOUNTDIR $d/cdrom.orig
+	    umount $MOUNTDIR; rmdir $MOUNTDIR
+	    rm -rf $d/cdrom; cp -a $d/cdrom.orig $d/cdrom
+	    patch -d $d/cdrom -p1 <$d/cdrom.patch
+	    tar cf - -C $d/cdrom.supplement . | tar xf - -C $d/cdrom
+	done
+    ;;
+
+    abort-upgrade|abort-remove|abort-deconfigure)
+    ;;
+
+    *)
+        echo "postinst called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
+
+
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/cdrom.supplement/isolinux/isolinux.cfg
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/cdrom.supplement/isolinux/isolinux.cfg	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/cdrom.supplement/isolinux/isolinux.cfg	(revision 452)
@@ -0,0 +1,6 @@
+PROMPT 1
+TIMEOUT 0
+DEFAULT sipb-xen-install
+LABEL sipb-xen-install
+       kernel /install.amd/vmlinuz
+       append auto=true preseed/file=/cdrom/preseed.cfg priority=critical vga=normal fb=false initrd=/install.amd/initrd.gz --
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/iso.url
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/iso.url	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/iso.url	(revision 452)
@@ -0,0 +1,1 @@
+http://cdimage.debian.org/debian-cd/4.0_r1/amd64/iso-cd/debian-40r1-amd64-businesscard.iso
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/preseed.cfg
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/preseed.cfg	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/srv/guest-installer/etch/preseed.cfg	(revision 452)
@@ -0,0 +1,224 @@
+#### Contents of the preconfiguration file
+d-i debian-installer/locale string en_US
+d-i console-keymaps-at/keymap select us
+
+### Network configuration
+# netcfg will choose an interface that has link if possible. This makes it
+# skip displaying a list if there is more than one interface.
+d-i netcfg/choose_interface select auto
+
+#d-i netcfg/dhcp_timeout string 1
+d-i netcfg/use_dhcp boolean true
+
+# Any hostname and domain names assigned from dhcp take precedence over
+# values set here. However, setting the values still prevents the questions
+# from being shown, even if values come from dhcp.
+# at bottom  #d-i netcfg/get_hostname string fillme
+d-i netcfg/get_domain string mit.edu
+
+# Disable that annoying WEP key dialog.
+d-i netcfg/wireless_wep string
+
+### Mirror settings
+# If you select ftp, the mirror/country string does not need to be set.
+#d-i mirror/protocol string ftp
+d-i mirror/country string enter information manually
+d-i mirror/http/hostname string debian.lcs.mit.edu
+d-i mirror/http/directory string /debian
+d-i mirror/http/proxy string
+
+# Suite to install.
+#d-i mirror/suite string testing
+# Suite to use for loading installer components (optional).
+#d-i mirror/udeb/suite string testing
+
+### Partitioning
+# If the system has free space you can choose to only partition that space.
+# Note: this must be preseeded with a localized (translated) value.
+#d-i partman-auto/init_automatically_partition \
+#      select Guided - use the largest continuous free space
+
+# Alternatively, you can specify a disk to partition. The device name
+# can be given in either devfs or traditional non-devfs format.
+# For example, to use the first disk:
+d-i partman-auto/disk string /dev/discs/disc0/disc
+# In addition, you'll need to specify the method to use.
+# The presently available methods are: "regular", "lvm" and "crypto"
+d-i partman-auto/method string regular
+
+# If one of the disks that are going to be automatically partitioned
+# contains an old LVM configuration, the user will normally receive a
+# warning. This can be preseeded away...
+d-i partman-auto/purge_lvm_from_device boolean true
+# And the same goes for the confirmation to write the lvm partitions.
+#d-i partman-lvm/confirm boolean true
+
+# You can choose from any of the predefined partitioning recipes.
+# Note: this must be preseeded with a localized (translated) value.
+d-i partman-auto/choose_recipe \
+       select All files in one partition (recommended for new users)
+#d-i partman-auto/choose_recipe \
+#       select Separate /home partition
+#d-i partman-auto/choose_recipe \
+#       select Separate /home, /usr, /var, and /tmp partitions
+
+# Or provide a recipe of your own...
+# The recipe format is documented in the file devel/partman-auto-recipe.txt.
+# If you have a way to get a recipe file into the d-i environment, you can
+# just point at it.
+#d-i partman-auto/expert_recipe_file string /hd-media/recipe
+
+# If not, you can put an entire recipe into the preconfiguration file in one
+# (logical) line. This example creates a small /boot partition, suitable
+# swap, and uses the rest of the space for the root partition:
+#d-i partman-auto/expert_recipe string                         \
+#      boot-root ::                                            \
+#              40 50 100 ext3                                  \
+#                      $primary{ } $bootable{ }                \
+#                      method{ format } format{ }              \
+#                      use_filesystem{ } filesystem{ ext3 }    \
+#                      mountpoint{ /boot }                     \
+#              .                                               \
+#              500 10000 1000000000 ext3                       \
+#                      method{ format } format{ }              \
+#                      use_filesystem{ } filesystem{ ext3 }    \
+#                      mountpoint{ / }                         \
+#              .                                               \
+#              64 512 300% linux-swap                          \
+#                      method{ swap } format{ }                \
+#              .
+
+# This makes partman automatically partition without confirmation.
+d-i partman/confirm_write_new_label boolean true
+d-i partman/choose_partition \
+       select Finish partitioning and write changes to disk
+d-i partman/confirm boolean true
+
+### Clock and time zone setup
+# Controls whether or not the hardware clock is set to UTC.
+d-i clock-setup/utc boolean true
+
+# You may set this to any valid setting for $TZ; see the contents of
+# /usr/share/zoneinfo/ for valid values.
+d-i time/zone string US/Eastern
+
+### Apt setup
+# You can choose to install non-free and contrib software.
+#d-i apt-setup/non-free boolean true
+#d-i apt-setup/contrib boolean true
+# Uncomment this if you don't want to use a network mirror.
+#d-i apt-setup/use_mirror boolean false
+# Uncomment this to avoid adding security sources, or
+# add a hostname to use a different server than security.debian.org.
+#d-i apt-setup/security_host string
+
+# Additional repositories, local[0-9] available
+#d-i apt-setup/local0/repository string \
+#       deb http://local.server/debian stable main
+#d-i apt-setup/local0/comment string local server
+# Enable deb-src lines
+#d-i apt-setup/local0/source boolean true
+# URL to the public key of the local repository; you must provide a key or
+# apt will complain about the unauthenticated repository and so the
+# sources.list line will be left commented out
+#d-i apt-setup/local0/key string http://local.server/key
+
+# By default the installer requires that repositories be authenticated
+# using a known gpg key. This setting can be used to disable that
+# authentication. Warning: Insecure, not recommended.
+#d-i debian-installer/allow_unauthenticated string true
+
+### Account setup
+# Skip creation of a root account (normal user account will be able to
+# use sudo).
+#d-i passwd/root-login boolean false
+# Alternatively, to skip creation of a normal user account.
+d-i passwd/make-user boolean false
+
+# Root password, either in clear text
+#d-i passwd/root-password password r00tme
+#d-i passwd/root-password-again password r00tme
+# or encrypted using an MD5 hash.
+# at bottom  #d-i passwd/root-password-crypted password [MD5 hash]
+
+# To create a normal user account.
+#d-i passwd/user-fullname string Debian User
+#d-i passwd/username string debian
+# Normal user's password, either in clear text
+#d-i passwd/user-password password insecure
+#d-i passwd/user-password-again password insecure
+# or encrypted using an MD5 hash.
+#d-i passwd/user-password-crypted password [MD5 hash]
+
+### Base system installation
+# Select the initramfs generator used to generate the initrd for 2.6 kernels.
+#d-i base-installer/kernel/linux/initramfs-generators string yaird
+
+### Boot loader installation
+# Grub is the default boot loader (for x86). If you want lilo installed
+# instead, uncomment this:
+#d-i grub-installer/skip boolean true
+
+# This is fairly safe to set, it makes grub install automatically to the MBR
+# if no other operating system is detected on the machine.
+d-i grub-installer/only_debian boolean true
+
+# This one makes grub-installer install to the MBR if it also finds some other
+# OS, which is less safe as it might not be able to boot that other OS.
+d-i grub-installer/with_other_os boolean true
+
+# Alternatively, if you want to install to a location other than the mbr,
+# uncomment and edit these lines:
+#d-i grub-installer/only_debian boolean false
+#d-i grub-installer/with_other_os boolean false
+#d-i grub-installer/bootdev  string (hd0,0)
+# To install grub to multiple disks:
+#d-i grub-installer/bootdev  string (hd0,0) (hd1,0) (hd2,0)
+
+### Package selection
+tasksel tasksel/first multiselect standard
+
+# Individual additional packages to install
+#d-i pkgsel/include string openssh-server build-essential
+
+### Finishing up the first stage install
+# Avoid that last message about the install being complete.
+d-i finish-install/reboot_in_progress note
+
+# This will prevent the installer from ejecting the CD during the reboot,
+# which is useful in some situations.
+#d-i cdrom-detect/eject boolean false
+
+### Preseeding other packages
+# Depending on what software you choose to install, or if things go wrong
+# during the installation process, it's possible that other questions may
+# be asked. You can preseed those too, of course. To get a list of every
+# possible question that could be asked during an install, do an
+# installation, and then run these commands:
+#   debconf-get-selections --installer > file
+#   debconf-get-selections >> file
+
+
+#### Advanced options
+### Running custom commands during the installation
+# d-i preseeding is inherently not secure. Nothing in the installer checks
+# for attempts at buffer overflows or other exploits of the values of a
+# preconfiguration file like this one. Only use preconfiguration files from
+# trusted locations! To drive that home, and because it's generally useful,
+# here's a way to run any shell command you'd like inside the installer,
+# automatically.
+
+# This first command is run as early as possible, just after
+# preseeding is read.
+#d-i preseed/early_command string anna-install some-udeb
+
+# This command is run just before the install finishes, but when there is
+# still a usable /target directory. You can chroot to /target and use it
+# directly, or use the apt-install and in-target commands to easily install
+# packages and run commands in the target system.
+#d-i preseed/late_command string apt-install zsh; in-target chsh -s /bin/zsh
+
+
+
+# sipb-xen: automatically filled-in values get appended here. 
+# at bottom  #d-i passwd/root-password-crypted password [MD5 hash]
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/usr/sbin/sipb-xen-lvcopy
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/usr/sbin/sipb-xen-lvcopy	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/usr/sbin/sipb-xen-lvcopy	(revision 452)
@@ -0,0 +1,82 @@
+#!/usr/bin/env python2.5
+
+import sys
+import os
+import shutil
+import tempfile
+import time
+from subprocess import call, check_call, Popen, PIPE
+
+def losetup(source, offset=0):
+  p = Popen(['sipb-xen-losetup', source, str(offset)], stdout=PIPE)
+  return p.communicate()[0].strip()
+
+def frob_copy_in_vm(target, *args):
+  '''UNUSED: maybe we'll use this someday; it does isolate the frobber.'''
+  # 1. prepare arguments volume
+  args_volume = prefix+target+'_args'
+  args_device = '/dev/xenvg/' + args_volume
+  check_call(['/sbin/lvcreate', 'xenvg', '--name', args_volume, '--size', '4K'])
+  file(args_device, 'w').write('\n'.join(args) + '\n')
+
+  # 2. invoke frobber vm
+  copier_device = '/dev/xenvg/d_wert_hda'
+  check_call(['/usr/sbin/xm', 'create', 'sipb-database',
+              'machine_name='+target,
+              'disks=' + ' '.join(['phy:'+copier_device+',hda,w',
+                                   'phy:'+target_device+',hdc,w',
+                                   'phy:'+args_device+',hdd,w'])])
+
+  # XXX should check_call(['/sbin/lvremove', '-f', 'xenvg/'+args_volume])
+
+def frob_copy(target, hostname, rootpw):
+  """target should be an LV device filename"""
+  # 1: mount filesystem
+  fs = losetup(target, 32256)
+  mntdir = tempfile.mkdtemp('', 'auto-install.frob.', '/tmp')
+  call(['mount', '-t', 'ext3', fs, mntdir])
+  # 2: do frobbing
+  call(['/usr/sbin/chroot', mntdir, '/post-copy', hostname, rootpw])
+  # 3: clean up
+  call(['umount', mntdir])
+  os.rmdir(mntdir)
+  call(['losetup', '-d', fs])
+
+def duplicate_by_vm(source, target, rootpw, nodd=False, nofrob=False):
+  # source, target should be machine names
+  prefix = 'd_'
+  # 1. copy (by dd) source to target
+  source_device = '/dev/xenvg/' + prefix + source + '_hda'
+  target_device = '/dev/xenvg/' + prefix + target + '_hda'
+  if not nodd:
+    check_call(['/bin/dd', 'bs=1M', 'conv=nocreat',
+                'if='+source_device, 'of='+target_device])
+  # 2. frob target
+  if not nofrob:
+    frob_copy(target_device, target, rootpw)
+
+def main(*argv):
+  subcommand = argv[1]
+  args = argv[2:]
+  os.environ['PATH'] = '/usr/sbin:/usr/bin:/sbin:/bin'
+  if subcommand == 'lvcopy':
+    kwargs = {}
+    while True:
+      if args[0].startswith('--'):
+        kwargs[args[0][2:]] = True
+        args = args[1:]
+        continue
+      if len(args) != 3:
+        print >>sys.stderr, argv[0]+': bad argument list'
+        return 2
+      break
+    duplicate_by_vm(*args, **kwargs)
+  elif subcommand == 'test':
+    pass
+  else:
+    print >>sys.stderr, argv[0]+": unknown subcommand: "+subcommand
+    return 2
+  return 0
+
+if __name__ == '__main__':
+  sys.exit(main(*sys.argv))
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/usr/sbin/sipb-xen-make-iso
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/usr/sbin/sipb-xen-make-iso	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/files/usr/sbin/sipb-xen-make-iso	(revision 452)
@@ -0,0 +1,30 @@
+#!/usr/bin/env python
+
+import sys
+import os
+import shutil
+import tempfile
+from subprocess import call
+
+data_dir = '/srv/guest-installer'
+
+def make_debian_cd(name, passhashfile):
+  basetree = os.path.join(data_dir, name)
+  tmptree = tempfile.mkdtemp('', 'auto-install.', '/tmp')
+  cdtree = os.path.join(tmptree, 'cdrom')
+  shutil.copytree(os.path.join(basetree, 'cdrom'), cdtree, symlinks=True)
+  new_preseed = file(os.path.join(cdtree, 'preseed.cfg'), 'w')
+  old_preseed = file(os.path.join(basetree, 'preseed.cfg'))
+  new_preseed.write(old_preseed.read())
+  passhash = file(passhashfile).read()
+  new_preseed.write('d-i passwd/root-password-crypted password '+passhash+'\n')
+  new_preseed.close()
+  output_iso = os.path.join(tmptree, 'install.iso')
+  call('''mkisofs -r -V "SIPB-Xen_Custom_Install_CD" -cache-inodes -J -l
+           -b isolinux/isolinux.bin -c isolinux/boot.cat
+           -no-emul-boot -boot-load-size 4 -boot-info-table'''.split()
+       + ['-o', output_iso, cdtree])
+  return output_iso
+
+if __name__ == '__main__':
+  print make_debian_cd(*sys.argv[1:])
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/partial/copying-installer.sh
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/partial/copying-installer.sh	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/partial/copying-installer.sh	(revision 452)
@@ -0,0 +1,15 @@
+#!/bin/bash
+# hda is the copying-installer image itself
+# hdb is unused (was the source image)
+# hdc is the target image
+# hdd is the arguments image
+
+exec 3</dev/hdd
+read -r -u 3 HOSTNAME
+read -r -u 3 ROOTPW
+exec 3<&-
+
+mount /dev/hdc1 /mnt/new
+/mnt/new/post-copy /mnt/new "$HOSTNAME" "$ROOTPW"
+umount /mnt/new
+sync
Index: package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/partial/post-copy
===================================================================
--- package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/partial/post-copy	(revision 452)
+++ package_tags/sipb-xen-guest-installer/1.0/sipb-xen-guest-installer/partial/post-copy	(revision 452)
@@ -0,0 +1,6 @@
+#!/bin/bash
+TARGET="$1"
+HOSTNAME="$2"
+ROOTPW="$3"
+(printf "%s\n" "$ROOTPW"; sleep .2; printf "%s\n" "$ROOTPW") \
+ | /usr/sbin/chroot "$TARGET" /usr/bin/passwd root