Index: package_tags/sipb-xen-base/5/debian/changelog
===================================================================
--- package_tags/sipb-xen-base/5/debian/changelog	(revision 457)
+++ package_tags/sipb-xen-base/5/debian/changelog	(revision 457)
@@ -0,0 +1,30 @@
+sipb-xen-base (5) unstable; urgency=low
+
+  * update sources.list, use sources.list.d
+
+ -- Greg Price <price@mit.edu>  Sat, 26 Apr 2008 21:06:05 -0400
+
+sipb-xen-base (4) unstable; urgency=low
+
+  * sipb-vm-1 becomes sipb-xen-dev
+
+ -- Sam Hartman <hartmans@debian.org>  Tue,  4 Sep 2007 15:48:50 -0400
+
+sipb-xen-base (3) unstable; urgency=low
+
+  * We want security updates too
+
+ -- Sam Hartman <hartmans@debian.org>  Fri, 10 Aug 2007 20:39:14 -0400
+
+sipb-xen-base (2) unstable; urgency=low
+
+  * Update sources.list to include our debian mirror
+
+ -- Sam Hartman <hartmans@debian.org>  Sat,  4 Aug 2007 19:11:18 -0400
+
+sipb-xen-base (1) unstable; urgency=low
+
+  * New upstream version
+
+ -- Sam Hartman <hartmans@debian.org>  Sat,  4 Aug 2007 18:44:21 -0400
+
Index: package_tags/sipb-xen-base/5/debian/compat
===================================================================
--- package_tags/sipb-xen-base/5/debian/compat	(revision 457)
+++ package_tags/sipb-xen-base/5/debian/compat	(revision 457)
@@ -0,0 +1,1 @@
+4
Index: package_tags/sipb-xen-base/5/debian/control
===================================================================
--- package_tags/sipb-xen-base/5/debian/control	(revision 457)
+++ package_tags/sipb-xen-base/5/debian/control	(revision 457)
@@ -0,0 +1,14 @@
+Source: sipb-xen-base
+Section: base
+Priority: extra
+Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 4.1.0)
+Standards-Version: 3.7.2
+
+Package: sipb-xen-base
+Architecture: all
+Depends: ${misc:Depends}, 
+Description: Base configuration required for all SIPB xen servers
+ This package includes apt configuration, .k5login and other files that
+ should be synchronized among all our servers.
+ Installing this on a non-sipb-xen machine would be very anti-social.
Index: package_tags/sipb-xen-base/5/debian/copyright
===================================================================
--- package_tags/sipb-xen-base/5/debian/copyright	(revision 457)
+++ package_tags/sipb-xen-base/5/debian/copyright	(revision 457)
@@ -0,0 +1,3 @@
+This package was created for internal use of the SIPB Xen Project of
+the MIT Student Information Processing Board.  Ask tabbott@mit.edu if
+you have questions about redistribution.
Index: package_tags/sipb-xen-base/5/debian/rules
===================================================================
--- package_tags/sipb-xen-base/5/debian/rules	(revision 457)
+++ package_tags/sipb-xen-base/5/debian/rules	(revision 457)
@@ -0,0 +1,4 @@
+#!/usr/bin/make -f
+
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: package_tags/sipb-xen-base/5/debian/sipb-xen-base.install
===================================================================
--- package_tags/sipb-xen-base/5/debian/sipb-xen-base.install	(revision 457)
+++ package_tags/sipb-xen-base/5/debian/sipb-xen-base.install	(revision 457)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/sipb-xen-base/5/files/etc/apt/sources.list.d/sipb-xen
===================================================================
--- package_tags/sipb-xen-base/5/files/etc/apt/sources.list.d/sipb-xen	(revision 457)
+++ package_tags/sipb-xen-base/5/files/etc/apt/sources.list.d/sipb-xen	(revision 457)
@@ -0,0 +1,2 @@
+deb     http://sipb-xen-dev.mit.edu/sipb-xen stable main
+deb-src http://sipb-xen-dev.mit.edu/sipb-xen stable main
Index: package_tags/sipb-xen-base/5/files/root/.k5login
===================================================================
--- package_tags/sipb-xen-base/5/files/root/.k5login	(revision 457)
+++ package_tags/sipb-xen-base/5/files/root/.k5login	(revision 457)
@@ -0,0 +1,22 @@
+hartmans@ATHENA.MIT.EDU
+hartmans/root@ATHENA.MIT.EDU
+jbarnold@ATHENA.MIT.EDU
+jbarnold/root@ATHENA.MIT.EDU
+andersk@ATHENA.MIT.EDU
+andersk/root@ATHENA.MIT.EDU
+nelhage@ATHENA.MIT.EDU
+nelhage/root@ATHENA.MIT.EDU
+tabbott@ATHENA.MIT.EDU
+tabbott/root@ATHENA.MIT.EDU
+asedeno@ATHENA.MIT.EDU
+asedeno/root@ATHENA.MIT.EDU
+quentin@ATHENA.MIT.EDU
+quentin/root@ATHENA.MIT.EDU
+danjared@ATHENA.MIT.EDU
+danjared/root@ATHENA.MIT.EDU
+ecprice@ATHENA.MIT.EDU
+ecprice/root@ATHENA.MIT.EDU
+zev@ATHENA.MIT.EDU
+zev/root@ATHENA.MIT.EDU
+mclamb@ATHENA.MIT.EDU
+mclamb/root@ATHENA.MIT.EDU